#ifndef _FEU_H
#define _FEU_H


#include "Led.h"
#define VERT 0
#define ORANGE 1
#define ROUGE 2
#define MODE_MANUEL 0
#define MODE_AUTO 1
#define MODE_ORANGE_CLI 2

//Cette classe reprsente un feu de signalisation bas sur trois leds directement connectes sur des ports d'une carte arduino
class Feu {
  private:
    //les trois leds du feu de signalisation: //leds[0]=vert, leds[1]=orange, leds[2]=rouge
    Led leds[3];

    //cet attribut reprsente l'tat du feu: 0=vert, 1=orange, 2=rouge
    int state;

    //cet attribut est un tableau qui contiendra les dures d'allumage des diffrentes leds (0=vert, 1=orange, 2=rouge)
    int durations[3];

  public:
    //Constructeur permettant d'initialiser un Feu  partir de trois Led - state=0(vert), durations=1000 (ms pour les trois)
    Feu(Led vert, Led orange, Led rouge);

    //getter: permet de rcuprer l'tat courant du Feu (0=vert, 1=orange, 2=rouge)
    inline const int get_state() const;

    //setter: permet de modifier l'tat courant du Feu(0=vert, 1=orange, 2=rouge)
    void set_state(int value);

  private:
    //mode de fonctionnement du Feu (0=manuel, 1=automatique, 2=orange clignotant)
    int mode;

  public:
    //getter: renvoir le mode de fonctionnement courant (0=manuel, 1=automatique, 2=orange clignotant)
    inline const int get_mode() const;

    //setter: permet de modifier le mode de fonctionnement courant (0=manuel, 1=automatique, 2=orange clignotant)
    void set_mode(int value);

    //setter: permet de rgler la dure d'une couleur
    void set_duration(int number, int duration);

    //setter: permet de rgler la dure des trois couleurs vert, orange, rouge
    void set_duration(int vert, int orange, int rouge);


    //Cette mthode permet de synchroniser le feu avec la boucle principal. Pour que le Feu fonctionne automatiquement, il faut l'appeler dans la boucle principale du programme. La fonction sync n'est pas bloquante.
    void sync();

};
//getter: permet de rcuprer l'tat courant du Feu (0=vert, 1=orange, 2=rouge)
inline const int Feu::get_state() const {
  return state;
}

//getter: renvoir le mode de fonctionnement courant (0=manuel, 1=automatique, 2=orange clignotant)
inline const int Feu::get_mode() const {
  return mode;
}

#endif
