#ifndef _LED_H
#define _LED_H

//La classe Led reprsente une led connecte sur une pin d'une carte arduino
class Led {
  private:
    //L'attribut state reprsente l'tat de la led (true=allume, false=teinte)
    bool state;

    //l'attribut pin reprsentele numro de la pin Arduino sur laquelle la led est branche
    int pin;

    //L'attribut oneLogic dcrit le mode de cablage (alumage par un niveau haut ou par un niveau bas)
    //oneLogic = true si allumage niveau haut
    bool oneLogic;


  public:
    inline const int get_pin() const;

    inline const bool get_state() const;

    void set_pin(int value);

    void set_oneLogic(bool value);

    //constructeur par dfaut: pin = -1 (non dfinie, state=false, oneLogic=true
    Led();

    //constructeur:  pin =numro de la pin Arduino, , oneLogic= type de logique de commande (high ou low)
    Led(int pin, bool oneLogic = true);

    //allume la led
    void lightOn();

    //Cette mthode teint la led
    void lightOff();

    //Cette mthode inverse l'tat de la led
    void invert();

    //Cette mthode allume la led pendant ms millisecondes puis l'teint
    void flash(int ms = 100);

  private:
    //cette mthode vrifie si le n de pin est valide (en fonction du type de carte: nano, uno, .etc.)
    bool validPin(int pin);
};

inline const int Led::get_pin() const {
  return pin;
}

inline const bool Led::get_state() const {
  return state;
}

#endif
